from emod_api import schema_to_class as s2c
import emod_api.interventions.common as common
import emod_api.interventions.utils as utils
from emodpy_tbhiv.interventions import purge_campaign_event

co_event = "ArtDistributed"

def ART(
        camp,
        trigger_treatment_list,
        start_day=0,
        duration=-1,
        property_restrictions_list=[],
        nodeIDs=[],
        black_period=0,
        black_trigger='Blackout',
        event_name='ART'):
    """
    ART
    :param TBD
    Note start_day is initialized as 1, recommend that this be aligned with the start of the simulation
    """
    # First, get the objects
    schema_path = camp.schema_path

    act_intervention = s2c.get_class_with_defaults( "ARTBasic", schema_path )
    act_intervention.Days_To_Achieve_Viral_Suppression = 183
    act_intervention.Viral_Suppression = True

    bcast_intervention = s2c.get_class_with_defaults( "BroadcastEvent", schema_path )
    bcast_intervention.Broadcast_Event = camp.get_send_trigger( co_event )

    event = common.TriggeredCampaignEvent( camp, start_day,event_name, utils.do_nodes( camp.schema_path, nodeIDs ), trigger_treatment_list, [ act_intervention, bcast_intervention ], Duration=duration, Property_Restrictions=property_restrictions_list )
    purge_campaign_event( event )

    return event

def new_intervention_as_file( camp, filename="art.json" ):
    camp.add( ART( camp, trigger_treatment_list=[ "Births" ] ) )
    camp.save( filename )
    return filename

